## visad
Class Gridded3DSet

    java.lang.Object
      visad.ThingImpl
          visad.DataImpl
              visad.Set
                  visad.SimpleSet
                      visad.SampledSet
                          visad.GriddedSet
                              visad.Gridded3DSet

All Implemented Interfaces:
  Cloneable, Data, GriddedSetIface, SampledSetIface, Serializable, SetIface, SimpleSetIface, Thing

Direct Known Subclasses:
  Gridded3DDoubleSet, Linear3DSet

public class Gridded3DSet
extends GriddedSet

Gridded3DSet represents a finite set of samples of R^3.

See Also:
  Serialized Form

Nested Class Summary

Nested classes inherited from class visad.DataImpl
`DataImpl.Syncher`

Nested classes inherited from class visad.ThingImpl
`ThingImpl.RemotePair`

Field Summary
`(package private) static int` `BIG_NEG` constants for isosurface, etc
`(package private) static int[]` `case_E9`
`(package private) static float` `EPS_0`
`(package private) static boolean` `FALSE`
`(package private) float` `HiX`
`(package private) float` `HiY`
`(package private) float` `HiZ`
`(package private) static int` `incXn`
`(package private) static int` `incYn`
`(package private) static int` `incZn`
`(package private) static int[]` `ITAB`
`(package private) int` `LengthX`
`(package private) int` `LengthY`
`(package private) int` `LengthZ`
`(package private) float` `LowX`
`(package private) float` `LowY`
`(package private) float` `LowZ`
`(package private) static int` `MASK`
`(package private) static int` `MAX_FLAG_NUM`
`(package private) static int[]` `NTAB`
`(package private) static int[][]` `pol_edges`
`(package private) static int` `SF_6B`
`(package private) static int` `SF_6D`
`(package private) static int` `SF_79`
`(package private) static int` `SF_97`
`(package private) static int` `SF_9E`
`(package private) static int` `SF_B6`
`(package private) static int` `SF_D6`
`(package private) static int` `SF_E9`
`(package private) static int[]` `sp_cases`
`(package private) static int[]` `STAB`
`(package private) static boolean` `TRUE`
`(package private) static int` `Xn`
`(package private) static int` `Xp`
`(package private) static int` `Yn`
`(package private) static int` `Yp`
`(package private) static int` `Zn`
`(package private) static int` `Zp`

Fields inherited from class visad.GriddedSet
`EPS, Lengths, Pos`

Fields inherited from class visad.SampledSet
`Hi, Low, Samples`

Fields inherited from class visad.SimpleSet
`ManifoldDimension`

Fields inherited from class visad.Set
`DomainCoordinateSystem, DomainDimension, hashCode, hashCodeSet, Length, SetErrors, SetUnits`

Fields inherited from class visad.DataImpl
`Type`

Fields inherited from interface visad.Data

`ABS, ACOS, ACOS_DEGREES, ADD, ASIN, ASIN_DEGREES, ATAN, ATAN_DEGREES, ATAN2, ATAN2_DEGREES, CEIL, COS, COS_DEGREES, DEGREES_TO_RADIANS, DEPENDENT, DIVIDE, EXP, FLOOR, INDEPENDENT, INV_ATAN2, INV_ATAN2_DEGREES, INV_DIVIDE, INV_POW, INV_REMAINDER, INV_SUBTRACT, LOG, MAX, MIN, MULTIPLY, NEAREST_NEIGHBOR, NEGATE, NO_ERRORS, NOP, POW, RADIANS_TO_DEGREES, REMAINDER, RINT, ROUND, SIN, SIN_DEGREES, SQRT, SUBTRACT, TAN, TAN_DEGREES, WEIGHTED_AVERAGE`

Constructor Summary
`Gridded3DSet(MathType type, float[][] samples, int lengthX)` a 3-D set with manifold dimension = 1, with null errors, CoordinateSystem and Units are defaults from type
`Gridded3DSet(MathType type, float[][] samples, int lengthX, CoordinateSystem coord_sys, Unit[] units, ErrorEstimate[] errors)` a 3-D set with manifold dimension = 1; samples array is organized float[3][number_of_samples] where lengthX = number_of_samples; no geometric constraint on samples; coordinate_system and units must be compatible with defaults for type, or may be null; errors may be null
`Gridded3DSet(MathType type, float[][] samples, int lengthX, CoordinateSystem coord_sys, Unit[] units, ErrorEstimate[] errors, boolean copy)`
`Gridded3DSet(MathType type, float[][] samples, int lengthX, int lengthY)` a 3-D set with manifold dimension = 2, with null errors, CoordinateSystem and Units are defaults from type

`Gridded3DSet(MathType type, float[][] samples, int lengthX, int lengthY, CoordinateSystem coord_sys, Unit[] units, ErrorEstimate[] errors)`
a 3-D set with manifold dimension = 2; samples array is organized float[3][number_of_samples] where lengthX * lengthY = number_of_samples; no geometric constraint on samples; the X component increases fastest in the second index of samples; coordinate_system and units must be compatible with defaults for type, or may be null; errors may be null

`Gridded3DSet(MathType type, float[][] samples, int lengthX, int lengthY, CoordinateSystem coord_sys, Unit[] units, ErrorEstimate[] errors, boolean copy)`
`Gridded3DSet(MathType type, float[][] samples, int lengthX, int lengthY, int lengthZ)` a 3-D set whose topology is a lengthX x lengthY x lengthZ grid, with null errors, CoordinateSystem and Units are defaults from type

`Gridded3DSet(MathType type, float[][] samples, int lengthX, int lengthY, int lengthZ, CoordinateSystem coord_sys, Unit[] units, ErrorEstimate[] errors)`
a 3-D set whose topology is a lengthX x lengthY x lengthZ grid; samples array is organized float[3][number_of_samples] where lengthX * lengthY * lengthZ = number_of_samples; samples must form a non-degenerate 3-D grid (no bow-tie-shaped grid cubes); the X component increases fastest and the Z component slowest in the second index of samples; coordinate_system and units must be compatible with defaults for type, or may be null; errors may be null

`Gridded3DSet(MathType type, float[][] samples, int lengthX, int lengthY, int lengthZ, CoordinateSystem coord_sys, Unit[] units, ErrorEstimate[] errors, boolean copy)`
`Gridded3DSet(MathType type, float[][] samples, int lengthX, int lengthY, int lengthZ, CoordinateSystem coord_sys, Unit[] units, ErrorEstimate[] errors, boolean copy, boolean test)`

Method Summary
`Object` `cloneButType(MathType type)` Clones this set -- changing the MathType.
`static int` `flags(float isovalue, int[] ptFLAG, int[] ptAUX, int[] pcube, float[] ptGRID, int xdim, int ydim, int zdim)`
`float[][]` `getNormals(float[][] grid)`
`float[]` `getStartPoint(float x, float y, float z)`
`float[][]` `gridToValue(float[][] grid)` transform an array of non-integer grid coordinates to an array of values in R^DomainDimension
`float[][]` `indexToValue(int[] index)` convert an array of 1-D indices to an array of values in R^DomainDimension
`static void` `main(String[] argv)` Simple DataImpl test, invoked as 'java visad.DataImpl'.
`(package private) static int[]` `make_lengths(int lengthX, int lengthY, int lengthZ)`
`static void` `make_normals(float[] VX, float[] VY, float[] VZ, float[] NX, float[] NY, float[] NZ, int nvertex, int npolygons, float[] Pnx, float[] Pny, float[] Pnz, float[] NxA, float[] NxB, float[] NyA, float[] NyB, float[] NzA, float[] NzB, int[] Pol_f_Vert, int[] Vert_f_Pol)`
`VisADGeometryArray` `make2DGeometry(byte[][] color_values, boolean indexed)` create a 2-D GeometryArray from this Set and color_values
`VisADGeometryArray[][]` `makeIsoLines(float[] intervals, float lowlimit, float highlimit, float base, float[] fieldValues, byte[][] color_values, boolean[] swap, boolean dash, boolean fill, ScalarMap[] smap, double scale, double label_size, float[][][] f_array)` return basic lines in array[0], fill-ins in array[1] and labels in array[2]
`VisADGeometryArray` `makeIsoSurface(float isolevel, float[] fieldValues, byte[][] color_values, boolean indexed)`
`static float[]` `makeNormals(float[] coordinates, int LengthX, int LengthY)`
`static int` `poly_triangle_stripe(int[] vet_pol, int[] Tri_Stripe, int nvertex, int npolygons, int[] Pol_f_Vert, int[] Vert_f_Pol)`
`float[][]` `valueToGrid(float[][] value)` transform an array of values in R^DomainDimension to an array of non-integer grid coordinates
`int[]` `valueToIndex(float[][] value)` convert an array of values in R^DomainDimension to an array of 1-D indices

Methods inherited from class visad.GriddedSet
`create, create, create, create, equals, getLength, getLengths, getNeighbors, getNeighbors, getWedge, hashCode, longString, makeSpatial, valueToInterp`

Methods inherited from class visad.SampledSet
`clone, computeRanges, computeRanges, cram_missing, cram_samples, getHi, getLow, getNeighbors, getSamples, getSamples, init_samples, init_samples, isMissing, make1DGeometry, make3DGeometry, makePointGeometry, setGeometryArray, setGeometryArray`

Methods inherited from class visad.SimpleSet
`getManifoldDimension, setAnimationSampling`

Methods inherited from class visad.Set
`__getitem__, __len__, addEqualsCache, addNotEqualsCache, adjustType, copyDoubles, copyFloats, doubleToFloat, doubleToIndex, equalUnitAndCS, floatToDouble, getCoordinateSystem, getDimension, getDimension, getDoubles, getDoubles, getLength, getSetErrors, getSetUnits, indexToDouble, longString, merge1DSets, testEqualsCache, testNotEqualsCache, unary, unitAndCSHashCode`

Methods inherited from class visad.DataImpl

`__add__, __add__, __div__, __div__, __mod__, __mod__, __mul__, __mul__, __neg__, __pow__, __pow__, __radd__, __rdiv__, __rmod__, __rmul__, __rpow__, __rsub__, __sub__, __sub__, abs, abs, acos, acos, acosDegrees, acosDegrees, add, add, adjustSamplingError, asin, asin, asinDegrees, asinDegrees, atan, atan, atan2, atan2, atan2Degrees, atan2Degrees, atanDegrees, atanDegrees, binary, binary, ceil, ceil, changeMathType, computeRanges, computeRanges, computeReferenceRanges, cos, cos, cosDegrees, cosDegrees, dataClone, divide, divide, exp, exp, floor, floor, getType, invertOp, local, log, log, max, max, min, min, multiply, multiply, negate, negate, notifyReferences, pow, pow, remainder, remainder, rint, rint, round, round, setParent, sin, sin, sinDegrees, sinDegrees, sqrt, sqrt, subtract, subtract, tan, tan, tanDegrees, tanDegrees, toString, unary`

Methods inherited from class visad.ThingImpl
`adaptedAddReference, adaptedRemoveReference, addReference, removeReference`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface visad.SampledSetIface
`getHi, getLow`

Methods inherited from interface visad.SetIface
`cram_missing, doubleToIndex, equalUnitAndCS, getCoordinateSystem, getDimension, getDoubles, getDoubles, getLength, getManifoldDimension, getNeighbors, getSamples, getSamples, getSetErrors, getSetUnits, indexToDouble, make1DGeometry, make3DGeometry, makePointGeometry, merge1DSets`

Methods inherited from interface visad.Data

`abs, abs, acos, acos, acosDegrees, acosDegrees, add, add, adjustSamplingError, asin, asin, asinDegrees, asinDegrees, atan, atan, atan2, atan2, atan2Degrees, atan2Degrees, atanDegrees, atanDegrees, binary, binary, ceil, ceil, changeMathType, computeRanges, computeRanges, computeRanges, cos, cos, cosDegrees, cosDegrees, dataClone, divide, divide, exp, exp, floor, floor, getType, isMissing, local, log, log, longString, max, max, min, min, multiply, multiply, negate, negate, pow, pow, remainder, remainder, rint, rint, round, round, sin, sin, sinDegrees, sinDegrees, sqrt, sqrt, subtract, subtract, tan, tan, tanDegrees, tanDegrees, unary, unary`

Methods inherited from interface visad.Thing
`addReference, removeReference`

Field Detail

### LengthX

    int LengthX

### LengthY

    int LengthY

### LengthZ

    int LengthZ

### LowX

    float LowX

### HiX

    float HiX

### LowY

    float LowY

### HiY

    float HiY

### LowZ

    float LowZ

### HiZ

    float HiZ

### BIG_NEG

    static final int BIG_NEG

  constants for isosurface, etc

  See Also:
    Constant Field Values

### EPS_0

    static final float EPS_0

See Also:
  Constant Field Values

### TRUE

    static final boolean TRUE

See Also:
  Constant Field Values

### FALSE

    static final boolean FALSE

See Also:
  Constant Field Values

### MASK

    static final int MASK

See Also:
  Constant Field Values

### MAX_FLAG_NUM

    static final int MAX_FLAG_NUM

See Also:
  Constant Field Values

### SF_6B

    static final int SF_6B

See Also:
  Constant Field Values

### SF_6D

    static final int SF_6D

See Also:
  Constant Field Values

### SF_79

    static final int SF_79

See Also:
  Constant Field Values

### SF_97

    static final int SF_97

See Also:
  Constant Field Values

### SF_9E

    static final int SF_9E

See Also:
  Constant Field Values

### SF_B6

    static final int SF_B6

See Also:
  Constant Field Values

### SF_D6

    static final int SF_D6

See Also:
  Constant Field Values

### SF_E9

    static final int SF_E9

See Also:
  Constant Field Values

### Zp

    static final int Zp

See Also:
  Constant Field Values

### Zn

    static final int Zn

See Also:
  Constant Field Values

### Yp

    static final int Yp

See Also:
  Constant Field Values

### Yn

    static final int Yn

See Also:
  Constant Field Values

### Xp

    static final int Xp

See Also:
  Constant Field Values

### Xn

    static final int Xn

See Also:
  Constant Field Values

### incZn

    static final int incZn

See Also:
  Constant Field Values

### incYn

    static final int incYn

See Also:
  Constant Field Values

### incXn

    static final int incXn

See Also:
  Constant Field Values

### pol_edges

    static final int[][] pol_edges

### sp_cases

    static final int[] sp_cases

### case_E9

    static final int[] case_E9

### NTAB

    static final int[] NTAB

### ITAB

    static final int[] ITAB

### STAB

    static final int[] STAB

Constructor Detail

### Gridded3DSet

    public Gridded3DSet(MathType type,
                        float[][] samples,
                        int lengthX,
                        int lengthY,
                        int lengthZ)
                 throws VisADException

  a 3-D set whose topology is a lengthX x lengthY x lengthZ grid, with null errors, CoordinateSystem and Units are defaults from type

### Gridded3DSet

    public Gridded3DSet(MathType type,
                        float[][] samples,
                        int lengthX,
                        int lengthY,
                        int lengthZ,
                        CoordinateSystem coord_sys,
                        Unit[] units,
                        ErrorEstimate[] errors)
                 throws VisADException

  a 3-D set whose topology is a lengthX x lengthY x lengthZ grid; samples array is organized float[3][number_of_samples] where lengthX * lengthY * lengthZ = number_of_samples; samples must form a non-degenerate 3-D grid (no bow-tie-shaped grid cubes); the X component increases fastest and the Z component slowest in the second index of samples; coordinate_system and units must be compatible with defaults for type, or may be null; errors may be null

### Gridded3DSet

    public Gridded3DSet(MathType type,
                        float[][] samples,
                        int lengthX,
                        int lengthY,
                        int lengthZ,
                        CoordinateSystem coord_sys,
                        Unit[] units,
                        ErrorEstimate[] errors,
                        boolean copy)
                 throws VisADException

### Gridded3DSet

    public Gridded3DSet(MathType type,
                        float[][] samples,
                        int lengthX,
                        int lengthY,
                        int lengthZ,
                        CoordinateSystem coord_sys,
                        Unit[] units,
                        ErrorEstimate[] errors,
                        boolean copy,
                        boolean test)
                 throws VisADException

### Gridded3DSet

    public Gridded3DSet(MathType type,
                        float[][] samples,
                        int lengthX,
                        int lengthY)
                 throws VisADException

  a 3-D set with manifold dimension = 2, with null errors, CoordinateSystem and Units are defaults from type

### Gridded3DSet

    public Gridded3DSet(MathType type,
                        float[][] samples,
                        int lengthX,
                        int lengthY,
                        CoordinateSystem coord_sys,
                        Unit[] units,
                        ErrorEstimate[] errors)
                 throws VisADException

  a 3-D set with manifold dimension = 2; samples array is organized float[3][number_of_samples] where lengthX * lengthY = number_of_samples; no geometric constraint on samples; the X component increases fastest in the second index of samples; coordinate_system and units must be compatible with defaults for type, or may be null; errors may be null

### Gridded3DSet

    public Gridded3DSet(MathType type,
                        float[][] samples,
                        int lengthX,
                        int lengthY,
                        CoordinateSystem coord_sys,
                        Unit[] units,
                        ErrorEstimate[] errors,
                        boolean copy)
                 throws VisADException

### Gridded3DSet

    public Gridded3DSet(MathType type,
                        float[][] samples,
                        int lengthX)
                 throws VisADException

  a 3-D set with manifold dimension = 1, with null errors, CoordinateSystem and Units are defaults from type

### Gridded3DSet

    public Gridded3DSet(MathType type,
                        float[][] samples,
                        int lengthX,
                        CoordinateSystem coord_sys,
                        Unit[] units,
                        ErrorEstimate[] errors)
                 throws VisADException

  a 3-D set with manifold dimension = 1; samples array is organized float[3][number_of_samples] where lengthX = number_of_samples; no geometric constraint on samples; coordinate_system and units must be compatible with defaults for type, or may be null; errors may be null

### Gridded3DSet

    public Gridded3DSet(MathType type,
                        float[][] samples,
                        int lengthX,
                        CoordinateSystem coord_sys,
                        Unit[] units,
                        ErrorEstimate[] errors,
                        boolean copy)
                 throws VisADException

Method Detail

### make_lengths

    static int[] make_lengths(int lengthX,
                              int lengthY,
                              int lengthZ)

### indexToValue

    public float[][] indexToValue(int[] index)
                           throws VisADException

  Description copied from class: `GriddedSet`
  convert an array of 1-D indices to an array of values in R^DomainDimension

  Specified by:
    `indexToValue` in interface `SetIface`
  Overrides:
    `indexToValue` in class `GriddedSet`
  Throws:
    `VisADException`

### valueToIndex

    public int[] valueToIndex(float[][] value)
                       throws VisADException

  convert an array of values in R^DomainDimension to an array of 1-D indices

  Specified by:
    `valueToIndex` in interface `SetIface`
  Overrides:
    `valueToIndex` in class `GriddedSet`
  Throws:
    `VisADException`

### gridToValue

    public float[][] gridToValue(float[][] grid)
                          throws VisADException

  transform an array of non-integer grid coordinates to an array of values in R^DomainDimension

  Specified by:
    `gridToValue` in interface `GriddedSetIface`
  Overrides:
    `gridToValue` in class `GriddedSet`
  Throws:
    `VisADException`

### valueToGrid

    public float[][] valueToGrid(float[][] value)
                          throws VisADException

  transform an array of values in R^DomainDimension to an array of non-integer grid coordinates

  Specified by:
    `valueToGrid` in interface `GriddedSetIface`
  Overrides:
    `valueToGrid` in class `GriddedSet`
  Throws:
    `VisADException`

### getStartPoint

    public float[] getStartPoint(float x,
                                 float y,
                                 float z)

### makeIsoLines

    public VisADGeometryArray[][] makeIsoLines(float[] intervals,
                                               float lowlimit,
                                               float highlimit,
                                               float base,
                                               float[] fieldValues,
                                               byte[][] color_values,
                                               boolean[] swap,
                                               boolean dash,
                                               boolean fill,
                                               ScalarMap[] smap,
                                               double scale,
                                               double label_size,
                                               float[][][] f_array)
                                        throws VisADException

  Description copied from class: `Set`
  return basic lines in array[0], fill-ins in array[1] and labels in array[2]

  Specified by:
    `makeIsoLines` in interface `SetIface`
  Overrides:
    `makeIsoLines` in class `Set`
  Throws:
    `VisADException`

### getNormals

    public float[][] getNormals(float[][] grid)
                         throws VisADException

  Throws:
    `VisADException`

### makeIsoSurface

    public VisADGeometryArray makeIsoSurface(float isolevel,
                                             float[] fieldValues,
                                             byte[][] color_values,
                                             boolean indexed)
                                      throws VisADException

  Specified by:
    `makeIsoSurface` in interface `SetIface`
  Overrides:
    `makeIsoSurface` in class `Set`
  Throws:
    `VisADException`

### flags

    public static int flags(float isovalue,
                            int[] ptFLAG,
                            int[] ptAUX,
                            int[] pcube,
                            float[] ptGRID,
                            int xdim,
                            int ydim,
                            int zdim)

### make_normals

    public static void make_normals(float[] VX,
                                    float[] VY,
                                    float[] VZ,
                                    float[] NX,
                                    float[] NY,
                                    float[] NZ,
                                    int nvertex,
                                    int npolygons,
                                    float[] Pnx,
                                    float[] Pny,
                                    float[] Pnz,
                                    float[] NxA,
                                    float[] NxB,
                                    float[] NyA,
                                    float[] NyB,
                                    float[] NzA,
                                    float[] NzB,
                                    int[] Pol_f_Vert,
                                    int[] Vert_f_Pol)
                             throws VisADException

  Throws:
    `VisADException`

### poly_triangle_stripe

    public static int poly_triangle_stripe(int[] vet_pol,
                                           int[] Tri_Stripe,
                                           int nvertex,
                                           int npolygons,
                                           int[] Pol_f_Vert,
                                           int[] Vert_f_Pol)
                                    throws VisADException

  Throws:
    `VisADException`

### makeNormals

    public static float[] makeNormals(float[] coordinates,
                                      int LengthX,
                                      int LengthY)

### make2DGeometry

    public VisADGeometryArray make2DGeometry(byte[][] color_values,
                                             boolean indexed)
                                      throws VisADException

  create a 2-D GeometryArray from this Set and color_values

  Specified by:
    `make2DGeometry` in interface `SetIface`
  Overrides:
    `make2DGeometry` in class `Set`
  Throws:
    `VisADException`

### cloneButType

    public Object cloneButType(MathType type)
                        throws VisADException

  Description copied from interface: `SetIface`
  Clones this set -- changing the MathType.

  Specified by:
    `cloneButType` in interface `SetIface`
  Overrides:
    `cloneButType` in class `GriddedSet`
  Throws:
    `VisADException`

### main

    public static void main(String[] argv)
                     throws VisADException

  Description copied from class: `DataImpl`
  Simple DataImpl test, invoked as 'java visad.DataImpl'.

  Throws:
    `VisADException`